class Cadena
{		
	private final String bases;
	
	public Cadena(final String bases) 
	{		
		this.bases = bases;
	}	
	
	public final String getBases()
	{
		return this.bases;
	}
	
	@Override
	public boolean equals(Object object)
	{			
		if(! (object instanceof Cadena))
			return false;
						
		Cadena otro = (Cadena)object;
		
		if(null == bases || null == otro.bases)
			return false;
		
		if(this.bases.length() != otro.bases.length())
			return false;
			
		if(this == otro) 
			return true;

        return -1 != (this.bases+this.bases).indexOf(otro.bases);	
		
	}	
	
}

public class CadenaADNApp 
{
	public static void main(String[] args)
	{
		Cadena cadena_1 = new Cadena("ATGCGTAT");
		Cadena cadena_2 = new Cadena("ATATGCGT");
		Cadena cadena_3 = new Cadena("AACGGTTT");
		Cadena cadena_4 = new Cadena(null);
		
		System.out.println(String.format("%s es igual a %s : %s", cadena_1.getBases(), cadena_2.getBases(), cadena_1.equals(cadena_2)));
		System.out.println(String.format("%s es igual a %s : %s", cadena_1.getBases(), cadena_3.getBases(), cadena_1.equals(cadena_3)));
		System.out.println(String.format("%s es igual a %s : %s", cadena_1.getBases(), cadena_4.getBases(), cadena_1.equals(cadena_4)));
	}
}


